-- Register the custom handlers when all mods are loaded
minetest.register_on_mods_loaded(function()
	for nodename, nodedef in pairs(minetest.registered_nodes) do
		-- Wrap and replace on_dig and on_place callbacks
		local original_on_dig = 
		local original_on_place = nodedef.on_place
		minetest.override_item(nodename, {
--[[
			on_place = function(itemstack, placer, pointed_thing)
				if original_on_place then
					return original_on_place(itemstack, placer, pointed_thing)
				else
					return minetest.item_place(itemstack, placer, pointed_thing)
				end
			end,
			on_dig = function(pos, node, digger)
				if original_on_dig then
					return original_on_dig(pos, node, digger)
				else
					minetest.node_dig(pos, node, digger)
				end
			end,
--]]
			--^ you would think that would work! ^
			node_placement_prediction=""
			-- If nil and item is node, prediction is made automatically.
			-- If nil and item is not a node, no prediction is made.
			-- If "" and item is anything, no prediction is made.
			-- Otherwise should be name of node which the client immediately places
			-- on ground when the player places the item. Server will always update
			-- with actual result shortly.
		})
	end
end)

